<script setup lang="ts">
import Chapter from '@/components/Chapter.vue'
import Post from '@/components/Post.vue'
import { useQuery } from 'vql'

const site = `${import.meta.env.VITE_SITE}`
const { data } = useQuery({ variables: { site } })
</script>

<template>
    <div v-if="data">
        <component
            v-for="item in data.site.rootPage.publication.children" 
            :key="item.slug"
            :is="item.pageType"
            :data="item"
        >
        </component>
    </div>
</template>

<script lang="ts">
export default {
  components: { Chapter, Post }
}
</script>

<gql>
query($site: String!){
  site(hostname:$site) {
    rootPage {
      publication {
        children {
        slug
        title
        pageType
        ... on Post {
          id
          parent {
            pageType
          }
          slug
          title
          abstract
          staged
          body {
            id
            blockType
            ... on EmbedBlock {
              embed
            }
            ... on RichTextBlock {
              rawValue
            }
            ... on StructBlock {
              rawValue
            }
          }
        }
        ... on Chapter {
          slug
          title
          staged
          children {
            title
            slug
            ... on Post {
              id
              parent {
                pageType
              }
              slug
              title
              abstract
              staged
              body {
                id
                blockType
                ... on EmbedBlock {
                  embed
                }
                ... on RichTextBlock {
                  rawValue
                }
                ... on StructBlock {
                  rawValue
                }
              }
            }
          }
        }
      }
      }
    }
  }
}
</gql>